class AreaDeltaScanServer implements Scan.Server<DistSumPoint, AreaDeltaBox, Integer> {
  public AreaDeltaBox init() { 
    AreaDeltaBox b = new AreaDeltaBox();
    b.zero = true;
    return b;
  }

  private AreaDeltaBox doAccum(AreaDeltaBox t, int x, int y) {
    AreaDeltaBox b = new AreaDeltaBox();
    b.zero = false;
    if (t.zero) {
      b.x_hi = b.x_lo = x;
      b.y_hi = b.y_lo = y;
    } else {
      b.x_hi = Math.max(x, t.x_hi);
      b.y_hi = Math.max(y, t.y_hi);
      b.x_lo = Math.min(x, t.x_lo);
      b.y_lo = Math.min(y, t.y_lo);
    }
    return b;
  }

  public AreaDeltaBox accum(AreaDeltaBox t, int i, DistSumPoint[] d) {
    return doAccum(t, d[i].x, d[i].y);
  }

  public AreaDeltaBox combine(AreaDeltaBox t1, AreaDeltaBox t2) {
    if (t1.zero)
      return t2;
    else
      return doAccum(doAccum(t2, t1.x_hi, t1.y_hi), t1.x_lo, t1.y_lo);
  }

  private int area(AreaDeltaBox t) {
    return ((t.x_hi - t.x_lo) * (t.y_hi - t.y_lo));
  }

  public AreaDeltaBox scanGen(AreaDeltaBox t, int i, DistSumPoint[] array, Integer[] result) {
    AreaDeltaBox t2;
    t2 = doAccum(t, array[i].x, array[i].y);
    result[i] = area(t2) - area(t);
    return t2;
  }
}
