class ConvertScanServer implements Scan.Server<Integer, Integer, Integer> {

  static int convert(int v) {
    int i;
    
    /* Arbitrary time-consuming calculation: */
    for (i = 0; i < 1000; i++) {
      v = ((v * v) + v) % 10;
    }
    
    return v;
  }
  
  static int deconvert(int v) {
    return convert(v);
  }


  public Integer init() { return 0; }

  public Integer accum(Integer t, int i, Integer[] array) {
    array[i] = convert(array[i]);
    return t + array[i];
  }

  public Integer combine(Integer t1, Integer t2) {
    return t1 + t2;
  }

  public Integer scanGen(Integer t, int i, Integer[] array, Integer[] result) {
    t += array[i];
    result[i] = deconvert(t);
    return t;
  }
}
