class Reduce<Data, Tally, Result> {
  int n;
  Data[] array;

  public interface Server<Data, Tally, Result> {
    public Tally init();
    public Tally accum(Tally t, int i, Data[] d);
    public Tally combine(Tally t1, Tally t2);
    public Result reduceGen(Tally t);
  }

  public interface ServerMaker<Data, Tally, Result> {
    public Server<Data, Tally, Result> make();
  }

  public interface Client<Data, Result> {
    public int getN();
    public Data[] getArray();
    
    public void setup();
    public void printResult(Result r);
  }

  public void run(String[] argv, ServerMaker<Data, Tally, Result> sm, Client<Data, Result> c) {
    Tally t1, t2;
    Server<Data, Tally, Result> s1, s2;
    Data[] dummy = new Object[20];

    c.setup();
    n = c.getN();
    array = c.getArray();

    s1 = sm.make();
    s2 = sm.make();

    t1 = s1.init();
    for (int i = 0; i < n/2; i++) {
      t1 = s1.accum(t1, i, array);
    }

    t2 = s2.init();
    for (int i = n/2; i < n; i++) {
      t2 = s1.accum(t2, i, array);
    }

    t1 = s1.combine(t1, t2);
    
    c.printResult(s1.reduceGen(t1));
  }
}
