class Scan<Data, Tally, Result> {
  int n;
  Data[] array;
  Result[] result;

  public interface Server<Data, Tally, Result> {
    public Tally init();
    public Tally accum(Tally t, int i, Data[] d);
    public Tally combine(Tally t1, Tally t2);
    public Tally scanGen(Tally t, int i, Data[] d, Result[] r);
  }

  public interface ServerMaker<Data, Tally, Result> {
    public Server<Data, Tally, Result> make();
  }

  public interface Client<Data, Result> {
    public int getN();
    public Data[] getArray();
    public Result[] getResult();
    
    public void setup();
    public void printResult();
  }

  public void run(String[] argv, ServerMaker<Data, Tally, Result> sm, Client<Data, Result> c) {
    Tally t1, t2, t0;
    Server<Data, Tally, Result> s1, s2;

    c.setup();
    n = c.getN();
    array = c.getArray();
    result = c.getResult();

    s1 = sm.make();
    s2 = sm.make();

    t1 = s1.init();
    t0 = t1;
    for (int i = 0; i < n/2; i++) {
      t1 = s1.accum(t1, i, array);
    }

    t2 = s2.init();
    for (int i = n/2; i < n; i++) {
      t2 = s1.accum(t2, i, array);
    }

    /* do second half first, just to mix things up */
    for (int i = n/2; i < n; i++) {
      t1 = s2.scanGen(t1, i, array, result);
    }

    for (int i = 0; i < n/2; i++) {
      t0 = s1.scanGen(t0, i, array, result);
    }

    c.printResult();
  }
}
